#ifndef __OBDCAN_H__
#define __OBDCAN_H__

#include <stdint.h>
#if defined(ARDUINO) && ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif
#include <HardwareSerial.h>


class OBDCan {
public:
    static const uint32_t BUFFER_SIZE = 128;
    static const uint32_t REQUEST_SIZE = 8;

    OBDCan() : serial_(0) {}
	bool init(HardwareSerial *serial);
	int32_t getPidAsInt(uint16_t pid);
	uint8_t getPidAsBytes(uint16_t pid, uint8_t* buffer, uint8_t bufferSize);
	uint8_t getProtocolNum();
private:
	uint8_t execCmd(const char* cmd, char* outBuffer, uint8_t maxLen);
	void send(const char* cmd);
	uint8_t receive(char* outBuffer, uint8_t maxLen);
	HardwareSerial* serial_;
};

const uint8_t BUFFER_SIZE = 128;
const uint8_t REQUEST_SIZE = 8;


#endif